//
//  JYCWindow.m
//  HOUNOLVJU
//
//  Created by 蒋永昌 on 9/24/16.
//  Copyright © 2016 蒋永昌. All rights reserved.
//

#import "EWEFloatingWindow.h"
#define kk_WIDTH self.frame.size.width
#define kk_HEIGHT self.frame.size.height

#define kScreenWidth [[UIScreen mainScreen] bounds].size.width
#define kScreenHeight [[UIScreen mainScreen] bounds].size.height

#define animateDuration 0.3 //位置改变动画时间
#define showDuration 0.1 //展开动画时间
#define statusChangeDuration 3.0 //状态改变时间
#define normalAlpha 1.0 //正常状态时背景alpha值
#define sleepAlpha 0.5 //隐藏到边缘时的背景alpha值
#define myBorderWidth 1.0 //外框宽度
#define marginWith 5 //间隔

#define WZFlashInnerCircleInitialRaius 20

@interface EWEFloatingWindow ()

@property (nonatomic) NSInteger frameWidth;
@property (nonatomic, strong) UIPanGestureRecognizer* pan;
@property (nonatomic, strong) UITapGestureRecognizer* tap;
@property (nonatomic, strong) UIButton* mainImageButton;
@property (nonatomic, strong) UIColor* bgcolor;
@property (nonatomic, strong) CAAnimationGroup* animationGroup;
@property (nonatomic, strong) CAShapeLayer* circleShape;
@property (nonatomic, strong) UIColor* animationColor;

/**
 原始key window
 */
@property (nonatomic, weak,readwrite) UIWindow* originalWindow;

@end
@implementation EWEFloatingWindow
- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code
    }
    return self;
}

static EWEFloatingWindow *window =nil;
/*EWEFloatingWindow(frame: CGRect(x: CGFloat(UIScreen.main.bounds.size.width - (60 * UIScreen.main.bounds.size.width / 375)), y: CGFloat(0), width: CGFloat(60 * UIScreen.main.bounds.size.width / 375), height: CGFloat(70 * UIScreen.main.bounds.size.width / 375)), mainImageName: "dcp_floatview_icon", bgcolor: UIColor.black)*/
+ (instancetype)share{
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        if (window == nil) {
            window = [[EWEFloatingWindow alloc] initWithFrame:CGRectMake( kScreenWidth - 60.0f * kScreenWidth / 375.0f , 0.0f, 60.0f * kScreenWidth / 375.0f, 70.0f * kScreenWidth / 375.0f) mainImageName:@"dcp_floatview_icon" bgcolor:[UIColor blackColor]];
        }
    });
    return window;
}

- (instancetype)initWithFrame:(CGRect)frame mainImageName:(NSString*)name bgcolor:(UIColor*)bgcolor
{
    return [self initWithFrame:frame mainImageName:name bgcolor:bgcolor animationColor:nil];
}

- (instancetype)initWithFrame:(CGRect)frame mainImageName:(NSString*)name bgcolor:(UIColor*)bgcolor animationColor:animationColor

{
    if (self = [super initWithFrame:frame]) {
        //NSAssert(name != nil, @"mainImageName can't be nil !");
        self.floatFrame = frame;
        self.backgroundColor = [UIColor clearColor];
        self.windowLevel = UIWindowLevelAlert - 1; //如果想在 alert 之上，则改成 + 2
        self.rootViewController = [[UINavigationController alloc] init];
        //[self makeKeyAndVisible];
        self.clipsToBounds = YES;

        _bgcolor = bgcolor;
        _frameWidth = frame.size.width;
        _animationColor = animationColor;
        //        [self doBorderWidth:myBorderWidth color:nil cornerRadius:_frameWidth/2];

        [self floatButtonWithFrame:frame imageName:name];
        
        _pan = [[UIPanGestureRecognizer alloc] initWithTarget:self action:@selector(locationChange:)];
        _pan.delaysTouchesBegan = NO;
        [self addGestureRecognizer:_pan];
        //        _tap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(click:)];
        //        [self addGestureRecognizer:_tap];

        [self performSelector:@selector(justbegin) withObject:nil afterDelay:statusChangeDuration];
    }
    return self;
}

- (void)floatButtonWithFrame:(CGRect)frame imageName:(NSString*)name{
    _mainImageButton = [UIButton buttonWithType:UIButtonTypeCustom];
    [_mainImageButton setFrame:(CGRect){ 2, 2, frame.size.width - 4, frame.size.height - 4}];
    if (name) {
        [_mainImageButton setImage:[UIImage imageNamed:name] forState:UIControlStateNormal];
    }
    _mainImageButton.backgroundColor = [UIColor whiteColor];
    _mainImageButton.layer.cornerRadius = 5;
    _mainImageButton.layer.borderWidth = 1.0f;
    _mainImageButton.layer.borderColor = [UIColor colorWithWhite:0.0f alpha:0.8f].CGColor;
    
    [self.layer layoutSublayers];
    [_mainImageButton addTarget:self action:@selector(click:) forControlEvents:UIControlEventTouchUpInside];
    if (_animationColor) {
        [_mainImageButton addTarget:self action:@selector(mainBtnTouchDown) forControlEvents:UIControlEventTouchDown];
    }
    [self addSubview:_mainImageButton];
}

- (void)dissmissWindow
{
    UINavigationController* naVC = (UINavigationController*)self.rootViewController;
    naVC.viewControllers = @[];
    self.hidden = YES;
    if (self.originalWindow) {
        id appDelegate = [[UIApplication sharedApplication] delegate];
        if ([appDelegate respondsToSelector:@selector(setWindow:)]) {
            [appDelegate performSelector:@selector(setWindow:) withObject:self.originalWindow];
        }
    }
    self.originalWindow = nil;

}
- (void)showWindow
{
    self.originalWindow = [[UIApplication sharedApplication] keyWindow];
    self.hidden = NO;
    [self sendSubviewToBack:self.mainImageButton];
    [self setFullScreen:YES];
    
}

- (void)justbegin
{

    [self performSelector:@selector(changeStatus) withObject:nil afterDelay:statusChangeDuration];

    CGPoint panPoint = CGPointMake(kScreenWidth - 80, kScreenHeight - 150);

    [self changBoundsabovePanPoint:panPoint];
}

- (void)changBoundsabovePanPoint:(CGPoint)panPoint
{
    if (panPoint.x <= kScreenWidth / 2) {
        if (panPoint.y <= 40 + kk_HEIGHT / 2 && panPoint.x >= 20 + kk_WIDTH / 2) {
            [UIView animateWithDuration:animateDuration animations:^{
                self.center = CGPointMake(panPoint.x, kk_HEIGHT / 2);
            }];
        }
        else if (panPoint.y >= kScreenHeight - kk_HEIGHT / 2 - 40 && panPoint.x >= 20 + kk_WIDTH / 2) {
            [UIView animateWithDuration:animateDuration animations:^{
                self.center = CGPointMake(panPoint.x, kScreenHeight - kk_HEIGHT / 2);
            }];
        }
        else if (panPoint.x < kk_WIDTH / 2 + 20 && panPoint.y > kScreenHeight - kk_HEIGHT / 2) {
            [UIView animateWithDuration:animateDuration animations:^{
                self.center = CGPointMake(kk_WIDTH / 2, kScreenHeight - kk_HEIGHT / 2);
            }];
        }
        else {
            CGFloat pointy = panPoint.y < kk_HEIGHT / 2 ? kk_HEIGHT / 2 : panPoint.y;
            [UIView animateWithDuration:animateDuration animations:^{
                self.center = CGPointMake(kk_WIDTH / 2, pointy);
            }];
        }
    }
    else if (panPoint.x > kScreenWidth / 2) {
        if (panPoint.y <= 40 + kk_HEIGHT / 2 && panPoint.x < kScreenWidth - kk_WIDTH / 2 - 20) {
            [UIView animateWithDuration:animateDuration animations:^{
                self.center = CGPointMake(panPoint.x, kk_HEIGHT / 2);
            }];
        }
        else if (panPoint.y >= kScreenHeight - 40 - kk_HEIGHT / 2 && panPoint.x < kScreenWidth - kk_WIDTH / 2 - 20) {
            [UIView animateWithDuration:animateDuration animations:^{
                self.center = CGPointMake(panPoint.x, kScreenHeight - kk_HEIGHT / 2);
            }];
        }
        else if (panPoint.x > kScreenWidth - kk_WIDTH / 2 - 20 && panPoint.y < kk_HEIGHT / 2) {
            [UIView animateWithDuration:animateDuration animations:^{
                self.center = CGPointMake(kScreenWidth - kk_WIDTH / 2, kk_HEIGHT / 2);
            }];
        }
        else {
            CGFloat pointy = panPoint.y > kScreenHeight - kk_HEIGHT / 2 ? kScreenHeight - kk_HEIGHT / 2 : panPoint.y;
            [UIView animateWithDuration:animateDuration animations:^{
                self.center = CGPointMake(kScreenWidth - kk_WIDTH / 2, pointy);
            }];
        }
    }
}
//改变位置
- (void)locationChange:(UIPanGestureRecognizer*)p
{
    if (self.fullScreen) {
        return;
    }
    CGPoint panPoint = [p locationInView:self.originalWindow];
    if (p.state == UIGestureRecognizerStateBegan) {
        [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(changeStatus) object:nil];
        _mainImageButton.alpha = normalAlpha;
    }
    if (p.state == UIGestureRecognizerStateChanged) {
        self.center = CGPointMake(panPoint.x, panPoint.y);
    }
    else if (p.state == UIGestureRecognizerStateEnded) {
        [self stopAnimation];
        [self performSelector:@selector(changeStatus) withObject:nil afterDelay:statusChangeDuration];

        [self changBoundsabovePanPoint:panPoint];
    }
}
//点击事件
- (void)click:(UITapGestureRecognizer*)p
{
    [self stopAnimation];
    self.fullScreen = YES;
    _mainImageButton.alpha = normalAlpha;

    //拉出悬浮窗
    if (self.center.x == 0) {
        self.center = CGPointMake(kk_WIDTH / 2, self.center.y);
    }
    else if (self.center.x == kScreenWidth) {
        self.center = CGPointMake(kScreenWidth - kk_WIDTH / 2, self.center.y);
    }
    else if (self.center.y == 0) {
        self.center = CGPointMake(self.center.x, kk_HEIGHT / 2);
    }
    else if (self.center.y == kScreenHeight) {
        self.center = CGPointMake(self.center.x, kScreenHeight - kk_HEIGHT / 2);
    }
}

#pragma mark - getting and setting

/**
 全屏/浮窗 之间切换

 @param fullScreen 是否为全屏
 */
- (void)setFullScreen:(BOOL)fullScreen{
    if (!fullScreen) {
        [self bringSubviewToFront:self.mainImageButton];
        self.frame = self.floatFrame;
        [self changBoundsabovePanPoint:CGPointMake(kScreenWidth - self.floatFrame.size.width/2, 0)];
        [self.rootViewController.view setHidden:YES];
    }else{
        self.frame = CGRectMake(0, 0, kScreenWidth, kScreenHeight);
        [self sendSubviewToBack:self.mainImageButton];
        [self.rootViewController.view setHidden:NO];
    }
    _fullScreen = fullScreen;
}

- (void)setImageMainButton:(UIImage *)imageMainButton{
    _imageMainButton = imageMainButton;
    [_mainImageButton setImage:_imageMainButton forState:UIControlStateNormal];
}

- (BOOL)isDisplay{
    if ([self isHidden]) {
        return NO;
    }
    return YES;
}

- (void)changeStatus
{

    //隐藏一半,和半透明的效果
    /*
    [UIView animateWithDuration:1.0 animations:^{
        _mainImageButton.alpha = sleepAlpha;
    }];
    [UIView animateWithDuration:0.5 animations:^{
        CGFloat x = self.center.x < 20 + kk_WIDTH / 2 ? 0 : self.center.x > kScreenWidth - 20 - kk_WIDTH / 2 ? kScreenWidth : self.center.x;
        CGFloat y = self.center.y < 40 + kk_HEIGHT / 2 ? 0 : self.center.y > kScreenHeight - 40 - kk_HEIGHT / 2 ? kScreenHeight : self.center.y;

        //禁止停留在4个角
        if ((x == 0 && y == 0) || (x == kScreenWidth && y == 0) || (x == 0 && y == kScreenHeight) || (x == kScreenWidth && y == kScreenHeight)) {
            y = self.center.y;
        }
        self.center = CGPointMake(x, y);
    }];
     */
}

//- (void)doBorderWidth:(CGFloat)width color:(UIColor *)color cornerRadius:(CGFloat)cornerRadius{
//    //  self.layer.masksToBounds = YES;
//    self.layer.cornerRadius = cornerRadius;
//    self.layer.borderWidth = width;
//    if (!color) {
//        self.layer.borderColor = [UIColor whiteColor].CGColor;
//    }else{
//        self.layer.borderColor = color.CGColor;
//    }
//}

#pragma mark------- animation -------------

- (void)buttonAnimation
{

    self.layer.masksToBounds = NO;

    CGFloat scale = 1.0f;
    //
    CGFloat width = self.mainImageButton.bounds.size.width, height = self.mainImageButton.bounds.size.height;
    //
    CGFloat biggerEdge = width > height ? width : height, smallerEdge = width > height ? height : width;
    CGFloat radius = smallerEdge / 2 > WZFlashInnerCircleInitialRaius ? WZFlashInnerCircleInitialRaius : smallerEdge / 2;

    scale = biggerEdge / radius + 0.5;
    _circleShape = [self createCircleShapeWithPosition:CGPointMake(width / 2, height / 2)
                                              pathRect:CGRectMake(0, 0, radius * 3, radius * 3)
                                                radius:radius];

    // 方形放大效果
    //            scale = 2.5f;
    //            _circleShape = [self createCircleShapeWithPosition:CGPointMake(width/2, height/2)
    //                                                     pathRect:CGRectMake(-CGRectGetMidX(self.mainImageButton.bounds), -CGRectGetMidY(self.mainImageButton.bounds), width, height)
    //                                                       radius:self.mainImageButton.layer.cornerRadius];

    [self.mainImageButton.layer addSublayer:_circleShape];

    CAAnimationGroup* groupAnimation = [self createFlashAnimationWithScale:scale duration:1.0f];

    [_circleShape addAnimation:groupAnimation forKey:nil];
}

- (void)stopAnimation
{

    [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(buttonAnimation) object:nil];

    if (_circleShape) {
        [_circleShape removeFromSuperlayer];
    }
}

- (CAShapeLayer*)createCircleShapeWithPosition:(CGPoint)position pathRect:(CGRect)rect radius:(CGFloat)radius
{
    CAShapeLayer* circleShape = [CAShapeLayer layer];
    circleShape.path = [self createCirclePathWithRadius:rect radius:radius];
    circleShape.position = position;

    // 雷达覆盖区域
    circleShape.bounds = CGRectMake(0, 0, radius * 3, radius * 3);
    circleShape.fillColor = _animationColor.CGColor;

    //  圆圈放大效果
    //  circleShape.fillColor = [UIColor clearColor].CGColor;
    //  circleShape.strokeColor = [UIColor purpleColor].CGColor;

    circleShape.opacity = 0;
    circleShape.lineWidth = 1;

    return circleShape;
}

- (CAAnimationGroup*)createFlashAnimationWithScale:(CGFloat)scale duration:(CGFloat)duration
{
    CABasicAnimation* scaleAnimation = [CABasicAnimation animationWithKeyPath:@"transform.scale"];
    scaleAnimation.fromValue = [NSValue valueWithCATransform3D:CATransform3DIdentity];
    scaleAnimation.toValue = [NSValue valueWithCATransform3D:CATransform3DMakeScale(scale, scale, 1)];

    CABasicAnimation* alphaAnimation = [CABasicAnimation animationWithKeyPath:@"opacity"];
    alphaAnimation.fromValue = @1;
    alphaAnimation.toValue = @0;

    _animationGroup = [CAAnimationGroup animation];
    _animationGroup.animations = @[ scaleAnimation, alphaAnimation ];
    _animationGroup.duration = duration;
    _animationGroup.repeatCount = INFINITY;
    _animationGroup.timingFunction = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseOut];
    return _animationGroup;
}

- (CGPathRef)createCirclePathWithRadius:(CGRect)frame radius:(CGFloat)radius
{
    return [UIBezierPath bezierPathWithRoundedRect:frame cornerRadius:radius].CGPath;
}

- (void)mainBtnTouchDown
{
    [self performSelector:@selector(buttonAnimation) withObject:nil afterDelay:0.5];
}

@end
