//
//  PullDownMenuCell.m
//  EWell
//
//  Created by pingguo on 16/3/7.
//  Copyright © 2016年 pingguo. All rights reserved.
//

#import "EWEPullDownMenuCell.h"

#define RGB(colorRgb, __a) [UIColor colorWithRed:((colorRgb & 0xFF0000) >> 16) / 255.0 green:((colorRgb & 0xFF00) >> 8) / 255.0 blue:((colorRgb & 0xFF) / 255.0) alpha:__a]

@implementation EWEPullDownMenuCell
+ (instancetype)pullDownMenuCellWithTableView:(UITableView*)tableView
{
    static NSString* ID = @"cell";
    EWEPullDownMenuCell* cell = [tableView dequeueReusableCellWithIdentifier:ID];
    if (cell == nil) {
        cell = [[EWEPullDownMenuCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:ID];
        cell.backgroundColor = RGB(0xf6fcfe, 1.0f);
        cell.textLabel.textColor = RGB(0x2cbdfb, 1.0f);
        cell.textLabel.font = [UIFont systemFontOfSize:20];
        cell.textLabel.textAlignment = NSTextAlignmentCenter;
        cell.textLabel.adjustsFontSizeToFitWidth = YES;
        cell.textLabel.minimumScaleFactor = 0.45f;
        UIView* aView = [[UIView alloc] initWithFrame:cell.contentView.frame];
        aView.backgroundColor = RGB(0xdbf2fa, 1.0f);
        cell.selectedBackgroundView = aView;
    }
    return cell;
}

- (void)setTextColor:(UIColor*)textColor
{
    _textColor = self.textColor;
    [self.textLabel setTextColor:self.textColor];
}

@end
