//
//  XMPullDownMenuView.h
//  EWell
//
//  Created by pingguo on 16/3/7.
//  Copyright © 2016年 pingguo. All rights reserved.
//

#import <UIKit/UIKit.h>

@class EWEPullDownMenuView;

/*!
 *  设置pullDownMenuView 的内容回调
 */
@protocol XMPullDownMenuViewDataSource <NSObject>

@required
/*!
 *  设置pullDownMenuView 的行数
 *
 *  @param pullDownMenuView
 *
 *  @return 行数
 */
- (NSInteger)xm_numberOfRowsWithPullDownMenuView:(EWEPullDownMenuView*)pullDownMenuView;
/*!
 *  设置pullDownMenuView 每行的值
 *
 *  @param pullDownMenuView
 *  @param row
 *
 *  @return 要显示的值
 */
- (NSString*)xm_tableView:(EWEPullDownMenuView*)pullDownMenuView setTitleForRow:(NSInteger)row;
@end

/*!
 *  触发事件回调
 */
@protocol XMPullDownMenuViewDelegate <NSObject>
@optional
/*!
 *  选择行回调
 *
 *  @param pullDownMenuView
 *  @param row
 */
- (void)xm_tableView:(EWEPullDownMenuView*)pullDownMenuView didSelectRow:(NSInteger)row;
@end
@interface EWEPullDownMenuView : UIView
/*!
 *  实例化
 *
 *  @return self
 */
+ (instancetype)pullDownMenuView;
// 0. 默认 1. 勾选框
@property (nonatomic, assign) NSInteger cellType;
// 0.单选 1. 多选
@property (nonatomic, assign) NSInteger selectedType;
/*!
 *  文字颜色
 */
@property (nonatomic, strong) UIColor* textColor;

/*!
 *  文字颜色
 */
@property (nonatomic, strong) UIFont* font;

@property (nonatomic, weak) id<XMPullDownMenuViewDataSource> dataSource;
@property (nonatomic, weak) id<XMPullDownMenuViewDelegate> delegate;
@property (weak, nonatomic) IBOutlet UITableView* tableView;

/*!
 *  被选定的行的索引
 *
 */
- (NSArray*)indexPathsForSelectedRows;

@end
