//
//  XMPullDownMenuView.m
//  EWell
//
//  Created by pingguo on 16/3/7.
//  Copyright © 2016年 pingguo. All rights reserved.
//

#import "EWEPullDownMenuCell.h"
#import "EWEPullDownMenuView.h"
#import "EWEPullDownSelectMenuCell.h"
@interface EWEPullDownMenuView () <UITableViewDataSource, UITableViewDelegate>

@property (strong,nonatomic) NSBundle *bundle;

@end
@implementation EWEPullDownMenuView

- (NSBundle *)bundle{
    if (_bundle == nil){
        _bundle = [NSBundle bundleForClass:[EWEPullDownMenuView class]];
//        NSURL* url = [bundle URLForResource:@"EWEllUI-Component" withExtension:@"bundle"];
//        if (url != nil) {
//            _bundle = [NSBundle bundleWithURL:url];
//        }
    }
    return _bundle;
}

+ (instancetype)pullDownMenuView
{
    //return [[NSBundle mainBundle] loadNibNamed:@"EWEPullDownMenuView" owner:nil options:nil];
    NSBundle *bundle = [NSBundle bundleForClass:[EWEPullDownMenuView class]];
    return [[bundle loadNibNamed:@"EWEPullDownMenuView" owner:nil options:nil] lastObject];
}

- (void)awakeFromNib{
    [super awakeFromNib];
    if (self.selectedType == 1) {
        [self.tableView setAllowsMultipleSelection:YES];
    }
}

#pragma mark - UITableViewDataSource
- (NSInteger)tableView:(UITableView*)tableView numberOfRowsInSection:(NSInteger)section
{
    return [self.dataSource xm_numberOfRowsWithPullDownMenuView:self];
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return 44;
}

- (UITableViewCell*)tableView:(UITableView*)tableView cellForRowAtIndexPath:(NSIndexPath*)indexPath
{
    if (self.cellType == 1) {
        EWEPullDownSelectMenuCell* cell = [tableView dequeueReusableCellWithIdentifier:@"PullDownSelectMenuCell"];
        if (cell == nil) {
            [tableView registerNib:[UINib nibWithNibName:@"EWEPullDownSelectMenuCell" bundle:self.bundle] forCellReuseIdentifier:@"PullDownSelectMenuCell"];
            cell = [tableView dequeueReusableCellWithIdentifier:@"PullDownSelectMenuCell"];
        }
        cell.title = [self.dataSource xm_tableView:self setTitleForRow:indexPath.row];
        cell.textColor = self.textColor;
        return cell;
    }
    EWEPullDownMenuCell* pCell = [EWEPullDownMenuCell pullDownMenuCellWithTableView:tableView];
    //设置文本
    pCell.textLabel.text = [self.dataSource xm_tableView:self setTitleForRow:indexPath.row];
    pCell.textColor = self.textColor;
    pCell.textLabel.font = self.font;
    return pCell;
}
#pragma mark - UITableViewDelegate
- (void)tableView:(UITableView*)tableView didSelectRowAtIndexPath:(NSIndexPath*)indexPath
{
    if ([self.delegate respondsToSelector:@selector(xm_tableView:didSelectRow:)]) {
        [self.delegate xm_tableView:self didSelectRow:indexPath.row];
    }
}

- (NSArray*)indexPathsForSelectedRows{
    return [self.tableView indexPathsForSelectedRows];
}
@end
