//
//  MedCategoryVController.m
//  EWell
//
//  Created by pingguo on 16/3/7.
//  Copyright © 2016年 pingguo. All rights reserved.
//

#import "EWEPullDownMenuView.h"
#import "EWEPullDownVController.h"
#import "UIButton+EWECategory.h"
#import "UIView+SetRect.h"

#define RGB(colorRgb, __a) [UIColor colorWithRed:((colorRgb & 0xFF0000) >> 16) / 255.0 green:((colorRgb & 0xFF00) >> 8) / 255.0 blue:((colorRgb & 0xFF) / 255.0) alpha:__a]

@interface EWEPullDownVController () <XMPullDownMenuViewDelegate, XMPullDownMenuViewDataSource>
@property (nonatomic, weak) EWEPullDownMenuView* menu;
@property (nonatomic, weak) UIButton* recordButton;
@property (nonatomic, strong) NSString* selectTitle;

@property (nonatomic, strong) UIButton* submitButton;
@property (nonatomic, strong) UIButton* cancelBUtton;
@end

@implementation EWEPullDownVController
#pragma mark - lazy
- (UIButton*)recordButton
{
    if (!_recordButton) {
        UIButton* button = [[UIButton alloc] init];
        self.recordButton = button;
    }
    return _recordButton;
}
- (void)viewDidLoad
{
    [super viewDidLoad];
    if (self.prefContentSize.height > 0) {
        self.preferredContentSize = self.prefContentSize;
    }
    else {
        self.preferredContentSize = CGSizeMake(345, 335);
    }

    //添加
    EWEPullDownMenuView* menu = [EWEPullDownMenuView pullDownMenuView];
    menu.cellType = self.cellType;
    menu.selectedType = self.selectedType;
    menu.font = self.font;
    menu.textColor = self.textColor;
    if (self.selectedType == 1) {
        menu.tableView.allowsMultipleSelection = YES;
    }
    //    [self.view.layer setBorderWidth:1.0f];
    //    [self.view.layer setBorderColor:[RGBColor(3, 169, 244) CGColor]];
    //    [self.view.layer setCornerRadius:11];
    menu.frame = self.view.bounds;
    menu.delegate = self;
    menu.dataSource = self;
    [self.view addSubview:menu];
    self.menu = menu;

    //保存uibutton
    __weak typeof(self) selfNew = self;
    self.ClickButtonBlock = ^(UIButton* btn) {
        selfNew.recordButton = btn;
    };

    if (self.cellType == 1) {

        //确认 button
        __weak typeof(self) weakSelf = self;
        UIButton* submitButton = [UIButton buttonWithType:UIButtonTypeCustom];
        [submitButton setTitle:@"确认" forState:UIControlStateNormal];
        submitButton.backgroundColor = RGB(0x2CBDFB, 1.0f);
        submitButton.layer.cornerRadius = 5.0f;
        [self.view addSubview:submitButton];
        submitButton.clickButton = ^{
            NSArray* selectedArray = [self selectedTitleArray];
            NSString* buttonTitle = self.selectTitle;
            NSMutableDictionary* dic = [NSMutableDictionary dictionary];
            if (self.selectedType == 1) {
                [dic setObject:selectedArray forKey:@"selectedArray"];
            }
            [dic setValue:buttonTitle forKey:@"buttonTitle"];

            [dic setValue:weakSelf.recordButton forKey:@"button"];
            [[NSNotificationCenter defaultCenter] postNotificationName:@"pullDownMenuViewDidChange" object:dic];
        };
        self.submitButton = submitButton;
        //取消 button
        UIButton* cancelButton = [UIButton buttonWithType:UIButtonTypeCustom];
        [cancelButton setTitle:@"取消" forState:UIControlStateNormal];
        cancelButton.backgroundColor = RGB(0xdddddd, 1.0f);
        cancelButton.layer.cornerRadius = 5.0f;
        [self.view addSubview:cancelButton];
        cancelButton.clickButton = ^{
            [weakSelf dismissViewControllerAnimated:YES completion:nil];
        };
        self.cancelBUtton = cancelButton;
    }
}

- (void)viewDidLayoutSubviews
{
    [super viewDidLayoutSubviews];
    self.menu.frame = self.view.bounds;
    if (self.cellType == 1) {
        self.menu.height = self.menu.height - 60;
    }

    self.submitButton.frame = CGRectMake(10, self.view.bounds.size.height - 50, (self.view.bounds.size.width - 40) / 2, 40);
    self.cancelBUtton.frame = CGRectMake((self.view.bounds.size.width - 40) / 2 + 30, self.view.bounds.size.height - 50, (self.view.bounds.size.width - 40) / 2, 40);
}

#pragma mark - XMPullDownMenuViewDataSource
- (NSInteger)xm_numberOfRowsWithPullDownMenuView:(EWEPullDownMenuView*)pullDownMenuView
{
    return self.types.count;
}
- (NSString*)xm_tableView:(EWEPullDownMenuView*)pullDownMenuView setTitleForRow:(NSInteger)row
{
    return self.types[row];
}
#pragma mark - XMPullDownMenuViewDelegate
- (void)xm_tableView:(EWEPullDownMenuView*)pullDownMenuView didSelectRow:(NSInteger)row
{
    switch (self.cellType) {
    case 1:
        self.selectTitle = self.types[row];
        break;

    default: {
        NSString* buttonTitle = self.types[row];
        NSMutableDictionary* dic = [NSMutableDictionary dictionary];
        [dic setValue:buttonTitle forKey:@"buttonTitle"];
        [dic setValue:self.recordButton forKey:@"button"];
        [dic setValue:[NSString stringWithFormat:@"%ld", (long)row] forKey:@"key"];
        [[NSNotificationCenter defaultCenter] postNotificationName:@"pullDownMenuViewDidChange" object:dic];
    } break;
    }
}
#pragma mark - 刷新
- (void)reloadData
{
    [self.menu.tableView reloadData];
}

#pragma mark - private func

- (NSMutableArray*)selectedTitleArray
{
    NSMutableArray* array = @[].mutableCopy;
    NSArray* indexPathsArray = [self.menu indexPathsForSelectedRows];
    for (NSIndexPath* indexPath in indexPathsArray) {
        [array addObject:[self.types objectAtIndex:indexPath.row]];
    }
    return array;
}

@end
