//
//  EWESideslipViewController.m
//  Demo
//
//  Created by William on 16/9/29.
//  Copyright © 2016年 LSF. All rights reserved.
//

#if __IPHONE_OS_VERSION_MAX_ALLOWED > __IPHONE_6_1
#define IF_IOS7_OR_GREATER(...) \
if (kCFCoreFoundationVersionNumber > kCFCoreFoundationVersionNumber_iOS_6_1) \
{ \
__VA_ARGS__ \
}
#else
#define IF_IOS7_OR_GREATER(...)
#endif


#define HEIGHT [UIScreen mainScreen].bounds.size.height
#define WIDTH [UIScreen mainScreen].bounds.size.width

#import "EWESideslipViewController.h"

@interface EWESideslipViewController()<UIGestureRecognizerDelegate>
@property (strong, nonatomic) UIView *menuViewContainer;
@property (assign, readwrite, nonatomic) CGPoint originalPoint;
@property (assign, readwrite, nonatomic) BOOL visible;
@property (assign, readwrite, nonatomic) BOOL didNotifyDelegate;
@property (strong, nonatomic) UIView *viwMenuBG;


@end

@implementation EWESideslipViewController

- (void)setDrawerViewController:(UIViewController *)drawerViewController{
    _drawerViewController = drawerViewController;
    [self.view addSubview:self.menuViewContainer];
    self.menuViewContainer.hidden = YES;
    self.menuViewContainer.frame = self.view.bounds;
    self.menuViewContainer.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
    [self.menuViewContainer addSubview:self.drawerViewController.view];
    self.drawerViewController.view.frame = self.menuViewContainer.bounds;
    [self addChildViewController:self.drawerViewController];
    [self.drawerViewController didMoveToParentViewController:self];
    UIPanGestureRecognizer *panGestureRecognizer = [[UIPanGestureRecognizer alloc] initWithTarget:self action:@selector(panGestureRecognized:)];
    panGestureRecognizer.delegate = self;
    [self.menuViewContainer addGestureRecognizer:panGestureRecognizer];
    
    [self.view insertSubview:self.viwMenuBG belowSubview:self.menuViewContainer];
    UITapGestureRecognizer *tapGestureRecognizer = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(tapGestuerRecognized:)];
    tapGestureRecognizer.delegate = self;
    [self.viwMenuBG addGestureRecognizer:tapGestureRecognizer];
}

#pragma mark - view cyclelift

- (void)viewDidLoad {
    [super viewDidLoad];
    
}

- (void)viewWillAppear:(BOOL)animated{
    [super viewWillAppear:animated];
}
- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    
    // 禁用 iOS7 返回手势
    if ([self.navigationController respondsToSelector:@selector(interactivePopGestureRecognizer)]) {
        self.navigationController.interactivePopGestureRecognizer.enabled = NO;
    }
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
    
    // 开启
    if ([self.navigationController respondsToSelector:@selector(interactivePopGestureRecognizer)]) {
        self.navigationController.interactivePopGestureRecognizer.enabled = YES;
    }
}

- (void)viewDidLayoutSubviews{
    [super viewDidLayoutSubviews];
    
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
 #pragma mark - Navigation
 
 // In a storyboard-based application, you will often want to do a little preparation before navigation
 - (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
 // Get the new view controller using [segue destinationViewController].
 // Pass the selected object to the new view controller.
 }
 */
/*!
 *  拉出抽屉View
 */
- (void)openDrawerView{
    for (UIView* obj in self.view.subviews) {
        if (obj == self.menuViewContainer || obj == self.viwMenuBG) {
            continue;
        }
        [obj setUserInteractionEnabled:NO];
    }
    [self.view bringSubviewToFront:self.menuViewContainer];
    self.menuViewContainer.transform = CGAffineTransformIdentity;
    CGPoint origin = self.view.bounds.origin;
    CGSize size = self.view.bounds.size;
    CGPoint drawerOpenCenter = [self centerOfHalfOpen];
    self.menuViewContainer.frame = CGRectMake(origin.x + WIDTH,origin.y, self.openWidth, size.height);
    self.drawerViewController.view.frame = self.menuViewContainer.bounds;
    [self updateContentViewShadow];
    //self.menuViewContainer.transform = CGAffineTransformMakeScale(1.5f, 1.5f);
    _menuViewContainer.hidden = NO;
    [self.drawerViewController beginAppearanceTransition:YES animated:YES];
    [[UIApplication sharedApplication] beginIgnoringInteractionEvents];
    [UIView animateWithDuration:0.35f animations:^{
        
        
        self.menuViewContainer.center = CGPointMake(drawerOpenCenter.x + - 10, drawerOpenCenter.y);
        
        self.menuViewContainer.alpha = 1.0f;
        self.menuViewContainer.transform = CGAffineTransformIdentity;
        //        self.menuViewContainer.transform = CGAffineTransformMakeScale(0.9f, 0);
        
    } completion:^(BOOL finished) {
        [self.drawerViewController endAppearanceTransition];
        //        self.menuViewContainer.transform = CGAffineTransformMakeScale(0.9f, 0);
        self.menuViewContainer.frame = CGRectMake(self.menuViewContainer.frame.origin.x, self.menuViewContainer.frame.origin.y, self.openWidth, self.menuViewContainer.frame.size.height);
        self.menuViewContainer.center = drawerOpenCenter;
        [[UIApplication sharedApplication] endIgnoringInteractionEvents];
        [self addContentViewControllerMotionEffects];
        [self.viwMenuBG setHidden:NO];
        self.visible = NO;
    }];
    
}

- (void)hideDrawerView{
    CGPoint drawerViewCenter = [self centerOfOpenDrawer];
    [self.drawerViewController beginAppearanceTransition:YES animated:YES];
    [[UIApplication sharedApplication] beginIgnoringInteractionEvents];
    [UIView animateWithDuration:0.2f animations:^{
    } completion:^(BOOL finished) {
        [self.drawerViewController endAppearanceTransition];
        self.menuViewContainer.center = CGPointMake(drawerViewCenter.x + self.openWidth + 10, drawerViewCenter.y);
        
        [[UIApplication sharedApplication] endIgnoringInteractionEvents];
        [self addContentViewControllerMotionEffects];
        for (UIView* obj in self.view.subviews) {
            [obj setUserInteractionEnabled:YES];
        }
        
        [self.viwMenuBG setHidden:YES];
        [self drawerViewDidHidden];
        self.visible = YES;
    }];
}

- (void)drawerViewDidHidden{

}


- (void)updateContentViewShadow
{
    CALayer *layer = self.menuViewContainer.layer;
    CGRect shadowRect = CGRectMake(0, 0, self.openWidth + 20, self.view.frame.size.height);
    UIBezierPath *path = [UIBezierPath bezierPathWithRect:shadowRect];
    layer.shadowPath = path.CGPath;
    layer.shadowColor = [UIColor blackColor].CGColor;
    layer.shadowOffset =  CGSizeMake(0, 0);
    layer.shadowOpacity = 0.6;
    layer.shadowRadius = 12;
}


- (void)addContentViewControllerMotionEffects
{
    IF_IOS7_OR_GREATER(
        //                for (UIMotionEffect *effect in self.contentViewContainer.motionEffects) {
        //                    [self.contentViewContainer removeMotionEffect:effect];
        //                }
        //                [UIView animateWithDuration:0.2 animations:^{
        // UIInterpolatingMotionEffect *interpolationHorizontal = [[UIInterpolatingMotionEffect alloc] initWithKeyPath:@"center.x" type:UIInterpolatingMotionEffectTypeTiltAlongHorizontalAxis];
        // interpolationHorizontal.minimumRelativeValue = @(self.parallaxContentMinimumRelativeValue);
        // interpolationHorizontal.maximumRelativeValue = @(self.parallaxContentMaximumRelativeValue);
        
        // UIInterpolatingMotionEffect *interpolationVertical = [[UIInterpolatingMotionEffect alloc] initWithKeyPath:@"center.y" type:UIInterpolatingMotionEffectTypeTiltAlongVerticalAxis];
        // interpolationVertical.minimumRelativeValue = @(self.parallaxContentMinimumRelativeValue);
        // interpolationVertical.maximumRelativeValue = @(self.parallaxContentMaximumRelativeValue);
        
        //        [self.contentViewContainer addMotionEffect:interpolationHorizontal];
        //        [self.contentViewContainer addMotionEffect:interpolationVertical];
//    }];
                       );
}

#pragma mark - GestureRecognizer

- (void)tapGestuerRecognized:(UITapGestureRecognizer *)recognizer{
    [self hideDrawerView];
}

- (void)panGestureRecognized:(UIPanGestureRecognizer *)recognizer
{
    
    CGPoint point = [recognizer translationInView:self.menuViewContainer];
    CGFloat progress = recognizer.view.frame.origin.x / (recognizer.view.bounds.size.width * 0.9);
    CGPoint drawerViewCenter = [self centerOfOpenDrawer];
    
    if (recognizer.state == UIGestureRecognizerStateBegan) {
        
    }
    
    if (recognizer.state == UIGestureRecognizerStateChanged) {
        
        CGPoint drawerViewCenter = [self centerOfOpenDrawer];
        if (self.menuViewContainer.center.x + point.x <= drawerViewCenter.x && point.x < 0) {
            return;
        }
        
        recognizer.view.center = CGPointMake(recognizer.view.center.x + point.x, recognizer.view.center.y);
        [recognizer setTranslation:CGPointZero inView:self.view];
        
    }
    
    if (recognizer.state == UIGestureRecognizerStateEnded) {
        
        /**
         *  手势结束时如果进度大于一半，那么就完成pop操作，否则重新来过。
         */
        if (progress > 0.5) {
            [self hideDrawerView];
            
        }else{
            [self.drawerViewController beginAppearanceTransition:YES animated:YES];
            [[UIApplication sharedApplication] beginIgnoringInteractionEvents];
            [UIView animateWithDuration:0.2f animations:^{
            } completion:^(BOOL finished) {
                [self.drawerViewController endAppearanceTransition];
                self.menuViewContainer.center = drawerViewCenter;
                
                [[UIApplication sharedApplication] endIgnoringInteractionEvents];
                [self addContentViewControllerMotionEffects];
                
            }];
            
        }
        
    }
}

#pragma mark - UIGestureRecognizerDelegate

- (BOOL)gestureRecognizer:(UIGestureRecognizer *)gestureRecognizer shouldBeRequiredToFailByGestureRecognizer:(UIGestureRecognizer *)otherGestureRecognizer{
    return NO;
}

#pragma mark - getting and setting

- (UIView*)menuViewContainer{
    if (!_menuViewContainer) {
        _menuViewContainer = [[UIView alloc] init];
    }
    return _menuViewContainer;
}

- (UIView *)viwMenuBG{
    if (!_viwMenuBG) {
        _viwMenuBG = [[UIView alloc] init];
        _viwMenuBG.frame = self.view.bounds;
        _viwMenuBG.backgroundColor = [UIColor clearColor];
    }
    return _viwMenuBG;
}


#pragma  mark - private

- (CGPoint)centerOfOpenDrawer{
    CGPoint point;
    //右滑
    point = CGPointMake(CGRectGetWidth(self.view.frame) - self.openWidth/2, self.menuViewContainer.center.y);
    return point;
}

- (CGPoint)centerOfHalfOpen{
    CGPoint point;
    //右滑
    point = CGPointMake(CGRectGetWidth(self.view.frame) + self.openWidth/2 - self.halfOpenWidth, self.menuViewContainer.center.y);
    return point;
}

@end
