//
//  EWEAlertView.h
//  EWEllUI_Component
//
//  Created by William on 16/10/8.
//  Copyright © 2016年 EWEll. All rights reserved.
//

#import <UIKit/UIKit.h>

typedef void (^AlertBlock)(NSInteger index);


typedef void (^AlertEditBlock)(NSInteger index,NSString* _Nonnull title);

@interface EWEAlertView : NSObject<UIAlertViewDelegate>

@property(nullable,nonatomic,copy) NSString *title;
@property(nullable,nonatomic,copy) NSString *message;   // secondary explanation text

@property (nullable,strong, nonatomic) UIAlertView* alertView;

@property (nullable,strong, nonatomic) UIAlertController* alertControl;
/*!
 *  选择回调
 */
@property (nullable,strong, nonatomic) AlertBlock block;

/*!
 *  自定义alertView 适应iOS 8,及以前
 *
 *  @param title                标题
 *  @param message              信息
 *  @param cancelButtonTitle    取消按键标题
 *  @param determineButtonTitle 确定按键标题
 *
 *  @return
 */
- (_Nullable instancetype)initWithTitle:(nullable NSString *)title message:(nullable NSString *)message cancelButtonTitle:(nullable NSString *)cancelButtonTitle determine:(nullable NSString*)determineButtonTitle;

//
/*!
 *  shows popup alert animated.
 *  显示 alertView
 */
- (void)show;

@end


@interface EWEEditAlertView : EWEAlertView

@property (nullable,nonatomic, strong) UITextField* textField;

/*!
 *  选择回调
 */
@property (nullable,strong, nonatomic) AlertEditBlock Editblock;

@end
