//
//  EWEAlertView.m
//  EWEllUI_Component
//
//  Created by William on 16/10/8.
//  Copyright © 2016年 EWEll. All rights reserved.
//

#import "EWEAlertView.h"

#define IOS8_OR_LATER ([[[UIDevice currentDevice] systemVersion] floatValue] >= 8)
@implementation EWEAlertView

- (instancetype)init{
    if (self = [super init]) {
    }
    return self;
}

- (instancetype)initWithTitle:(NSString *)title message:(NSString *)message cancelButtonTitle:(NSString *)cancelButtonTitle determine:(NSString *)determineButtonTitle{
    if (self = [super init]) {
        if (IOS8_OR_LATER) {
            _alertControl = [UIAlertController alertControllerWithTitle:title message:message preferredStyle:UIAlertControllerStyleAlert];
            UIAlertAction* cancelAction = [UIAlertAction actionWithTitle:cancelButtonTitle style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
                if (self.block) {
                    self.block(0);
                }
            }];
            UIAlertAction* determineAction = [UIAlertAction actionWithTitle:determineButtonTitle style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
                if (self.block) {
                    self.block(1);
                }
            }];
            [_alertControl addAction:cancelAction];
            [_alertControl addAction:determineAction];
            
        }else{
            _alertView = [[UIAlertView alloc] initWithTitle:title message:message delegate:self cancelButtonTitle:cancelButtonTitle otherButtonTitles:determineButtonTitle, nil];
            
        }
    }
    return self;
}

- (void)setTitle:(NSString *)title{
    if (IOS8_OR_LATER) {
        [self.alertControl setTitle:title];
    }else{
        [self.alertView setTitle:title];
    }
}

- (void)setMessage:(NSString *)message{
    if (IOS8_OR_LATER) {
        [self.alertControl setMessage:message];
    }else{
        [self.alertView setMessage:message];
    }
}

- (void)show{
    if (IOS8_OR_LATER) {
        UIViewController* rootVC = [[[UIApplication sharedApplication] keyWindow] rootViewController];
        [rootVC presentViewController:self.alertControl animated:YES completion:nil];
    }else{
        [self.alertView show];
    }
}

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex{
    if (self.block) {
        self.block(buttonIndex);
    }
}

@end


@implementation EWEEditAlertView

- (instancetype)initWithTitle:(NSString *)title message:(NSString *)message cancelButtonTitle:(NSString *)cancelButtonTitle determine:(NSString *)determineButtonTitle{
    if (self = [super init]) {
        if (IOS8_OR_LATER) {
            self.alertControl = [UIAlertController alertControllerWithTitle:title message:message preferredStyle:UIAlertControllerStyleAlert];
            UIAlertAction* cancelAction = [UIAlertAction actionWithTitle:cancelButtonTitle style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
                if (self.Editblock) {
                    self.Editblock(0,self.textField.text);
                }
            }];
            UIAlertAction* determineAction = [UIAlertAction actionWithTitle:determineButtonTitle style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
                if (self.Editblock) {
                    self.Editblock(1,self.textField.text);
                }
            }];
            [self.alertControl addAction:cancelAction];
            [self.alertControl addAction:determineAction];
            
        }else{
            self.alertView = [[UIAlertView alloc] initWithTitle:title message:message delegate:self cancelButtonTitle:cancelButtonTitle otherButtonTitles:determineButtonTitle, nil];
        }
    }
    [self configTextField];
    return self;

}

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex{
    if (self.Editblock) {
        self.Editblock(buttonIndex,self.textField.text);
    }

}

- (void)configTextField{
    if (!_textField) {
        if (IOS8_OR_LATER) {
            [self.alertControl addTextFieldWithConfigurationHandler:^(UITextField * _Nonnull textField) {
                _textField = textField;
            }];
        }else{
            _textField = [[UITextField alloc] initWithFrame:CGRectMake(0, 0, 400, 35)];
            [self.alertView setValue:_textField forKey:@"accessoryView"];
        }
    }
}

@end

