//
//  EMDTDelayButton.m
//  emdtfree
//
//  Created by wangwenjie on 2017/1/3.
//  Copyright © 2017年 EWEll. All rights reserved.
//

#import "EMDTDelayButton.h"
#import <objc/runtime.h>

@interface EMDTDelayButton ()

@property (copy, nonatomic) NSString* oldText;
@property (assign, nonatomic) NSInteger second;
@property (assign, nonatomic) NSInteger delayTime;
@property (strong, nonatomic) NSTimer* delayTimeer;
@property (strong, nonatomic) UIColor* oldColor;
@property (strong, nonatomic) NSDate* endDate;

@end

@implementation EMDTDelayButton

- (void)awakeFromNib
{
    [super awakeFromNib];
    self.oldText = [self.titleLabel.text copy];
    self.oldColor = [UIColor colorWithCGColor:[self.backgroundColor CGColor]];
    //[self addTarget:self action:@selector(delayButtonClicked) forControlEvents:UIControlEventTouchUpInside];
}

- (instancetype)init
{
    if (self = [super init]) {
        // [self addTarget:self action:@selector(delayButtonClicked) forControlEvents:UIControlEventTouchUpInside];
    }
    return self;
}
//重载setEnabled方法 重置计时器
- (void)setEnabled:(BOOL)enabled{
    [super setEnabled:enabled];
    if (enabled) {
        [self setTitle:[NSString stringWithFormat:@"%ld秒",(long)self.delayTime] forState:UIControlStateDisabled];
        [self.delayTimeer invalidate];
        self.second = 0;
        [self setTitle:self.oldText forState:UIControlStateNormal];
        self.backgroundColor = self.oldColor;
    }
    
}

- (void)startShowDelayTime{
    if (!self.delayTime || self.delayTime < 1 ) {
        self.delayTime = 60;
    }
    self.endDate = [NSDate dateWithTimeIntervalSinceNow:self.delayTime];
    if (!self.oldText || !self.oldColor) {
        self.oldText = [self.titleLabel.text copy];
        self.oldColor = [UIColor colorWithCGColor:[self.backgroundColor CGColor]];
    }
    self.enabled = NO;
    self.backgroundColor = [UIColor grayColor];
    [self startDelayTimeer];
}

//设置等待时间
- (void)setMaxDelayTime:(NSInteger)delayTime{
    self.delayTime = delayTime;
}
//开始计时器
- (void)startDelayTimeer{
    self.delayTimeer = [NSTimer scheduledTimerWithTimeInterval:1.0f target:self selector:@selector(updateTitle) userInfo:nil repeats:YES];
}
//更新button显示的秒数
- (void)updateTitle{
    self.second = [self.endDate timeIntervalSinceDate:[NSDate dateWithTimeIntervalSinceNow:0]];
    if (self.second > 0) {
        [self setTitle:[NSString stringWithFormat:@"%ld秒",(long)self.second] forState:UIControlStateDisabled];
    }else{
        [self setTitle:[NSString stringWithFormat:@"%ld秒",(long)self.delayTime] forState:UIControlStateDisabled];
        self.second = 0;
        [self.delayTimeer invalidate];
        [self setTitle:self.oldText forState:UIControlStateNormal];
        self.enabled = YES;
        self.backgroundColor = self.oldColor;
    }
}

@end
