//
//  EWEUPDownStructureButton.m
//  MDTPro_fuzhou
//
//  Created by William on 16/8/3.
//  Copyright © 2016年 EWell. All rights reserved.
//

#import "EWEUPDownStructureButton.h"

#define HEIGHT [UIScreen mainScreen].bounds.size.height
#define WIDTH [UIScreen mainScreen].bounds.size.width

@interface EWEUPDownStructureButton()

@property (nonatomic,assign) CGRect oldImageFrame;

@end

/**
 *  uibutton的图片和文字结构为上下结构
 */

@implementation EWEUPDownStructureButton

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

- (void)awakeFromNib{
    [super awakeFromNib];
    self.middleSpacing   = 5;
    self.imageTopSpacing = 0;
    self.titleLabel.lineBreakMode = 0;
}

- (void)layoutSubviews{
    [super layoutSubviews];
    self.titleLabel.numberOfLines = 1;
    //self.titleLabel.minimumScaleFactor = 0.5;
    //self.titleLabel.adjustsFontSizeToFitWidth = YES;
    self.imageView.contentMode = UIViewContentModeScaleAspectFit;

    // Center image
    CGRect imageFrame = CGRectMake(self.oldImageFrame.origin.x, self.oldImageFrame.origin.y, self.oldImageFrame.size.width * (WIDTH / 375.0), self.oldImageFrame.size.height * (WIDTH / 375.0));
    self.imageView.frame = imageFrame;
    
    CGPoint center = self.imageView.center;
    center.x = self.frame.size.width/2;
    center.y = self.imageView.frame.size.height/2 + self.imageTopSpacing;
    self.imageView.center = center;
    
    //Center text
    CGRect tempFrame = [self titleLabel].frame;
    tempFrame.origin.x = 0;
    tempFrame.origin.y = self.imageView.frame.size.height + self.middleSpacing + self.imageTopSpacing;
    tempFrame.size.width = self.frame.size.width;
    tempFrame.size.height = self.titleLabel.font.pointSize +2;
    self.titleLabel.frame = tempFrame;
    //UILabel*
    self.titleLabel.textAlignment = NSTextAlignmentCenter;

}

#pragma mark - Getting && Setting

- (CGRect)oldImageFrame{
    if (CGRectEqualToRect(_oldImageFrame, CGRectZero)) {
        _oldImageFrame = self.imageView.frame;
    }
    return _oldImageFrame;
}

@end
