//
//  UIImage+EWECategory.m
//  EWEllUI_Component
//
//  Created by William on 16/9/8.
//  Copyright © 2016年 EWEll. All rights reserved.
//

#import "UIImage+EWECategory.h"

@implementation UIImage (EWECategory)


+ (UIImage*)convertViewToImage:(UIView*)v
{
    UIImage* image;
    UIGraphicsBeginImageContextWithOptions(v.bounds.size, NO, [UIScreen mainScreen].scale);
    [v.layer renderInContext:UIGraphicsGetCurrentContext()];
    image = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    return image;
}

+ (UIImage *)imageWithColor:(UIColor *)color size:(CGSize)size
{
    CGRect rect = CGRectMake(0, 0, size.width, size.height);
    UIGraphicsBeginImageContext(rect.size);
    CGContextRef context = UIGraphicsGetCurrentContext();
    CGContextSetFillColorWithColor(context,color.CGColor);
    CGContextFillRect(context, rect);
    UIImage *img = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    
    return img;
}


+ (UIImage *)createOtherMerchantImage:(NSString *)nickName withFont:(CGFloat)fontSize withTextColor:(UIColor *)textColor

{

    UIImage *image = [UIImage new];
    CGFloat w = [UIScreen mainScreen].bounds.size.width;
    CGSize size = [nickName boundingRectWithSize:CGSizeMake(w, 200)  options:NSStringDrawingUsesLineFragmentOrigin attributes:@{ NSFontAttributeName :[ UIFont fontWithName : @"PingFang SC" size : fontSize ]} context:nil].size;
    
    UIGraphicsBeginImageContextWithOptions (size, NO , 0.0 );
    [image drawAtPoint : CGPointMake ( 0 , 0 )];
    
    // 获得一个位图图形上下文
    
    CGContextRef context= UIGraphicsGetCurrentContext ();
    
    CGContextDrawPath (context, kCGPathStroke );
    
    //画自己想画的内容。。。。。
    
    NSMutableParagraphStyle *paragraphStyle = [[NSParagraphStyle defaultParagraphStyle] mutableCopy];
    paragraphStyle.lineBreakMode = NSLineBreakByCharWrapping;
    paragraphStyle.alignment = NSTextAlignmentLeft;
    UIFont * font = [UIFont systemFontOfSize: fontSize];
    //计算文字的宽度和高度：支持多行显示
    CGSize sizeText = [nickName boundingRectWithSize:size
                                        options:NSStringDrawingUsesLineFragmentOrigin
                                     attributes:@{
                                                  NSFontAttributeName:font,//设置文字的字体
                                                  //                                                  NSKernAttributeName:@10,//文字之间的字距
                                                  //                                                  NSForegroundColorAttributeName:[UIColor greenColor]
                                                  }
                                        context:nil].size;
    
    //为了能够垂直居中，需要计算显示起点坐标x,y
    CGRect rect = CGRectMake((size.width-sizeText.width)/2, (size.height-sizeText.height)/2, sizeText.width, sizeText.height);
    
    
    [nickName drawInRect:rect withAttributes:@{ NSFontAttributeName :[ UIFont fontWithName : @"PingFang SC" size : fontSize ], NSForegroundColorAttributeName :textColor,NSParagraphStyleAttributeName:paragraphStyle} ];
    
    //画自己想画的内容。。。。。
    
    // 返回绘制的新图形
    
    UIImage *newImage= UIGraphicsGetImageFromCurrentImageContext ();
    
    UIGraphicsEndImageContext ();
    
    return newImage;
    
}



@end
