//
//  EWEIndexTableView.m
//  Demo
//
//  Created by William on 16/9/28.
//  Copyright © 2016年 LSF. All rights reserved.
//

#import "EWEIndexTableView.h"

@interface EWEIndexTableView()<UITableViewDelegate,UITableViewDataSource>

@property (strong, nonatomic) NSString* key;

@end

@implementation EWEIndexTableView

- (instancetype)init{
    if (self = [super init]) {
        self.tavList = [[UITableView alloc] init];
        self.tavList.backgroundColor = [UIColor clearColor];
        self.tavList.separatorStyle = UITableViewCellSeparatorStyleNone;
        self.tavList.showsVerticalScrollIndicator = NO;
        self.tavList.delegate = self;
        self.tavList.dataSource = self;
        self.tavList.frame = CGRectMake(0, 0, 0, 0);
        [self addSubview:self.tavList];
    }
    return self;
}

- (void)layoutSubviews{
    [super layoutSubviews];
    self.tavList.frame = CGRectMake(0, 0, self.frame.size.width, self.frame.size.height);
}

#pragma mark - tableview delegate

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return self.titles.count;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return self.cellHeight;
}

- (UITableViewCell*)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    static NSString* ID = @"Cell";
    UITableViewCell* cell = [tableView dequeueReusableCellWithIdentifier:ID];
    if (!cell) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:ID];
        cell.backgroundColor = [UIColor clearColor];
        cell.textLabel.textColor = self.cellTintColor;
        cell.textLabel.highlightedTextColor = [UIColor whiteColor];
        cell.textLabel.font = self.font;
        cell.textLabel.textAlignment = NSTextAlignmentCenter;
        //    cell.textLabel.adjustsFontSizeToFitWidth = YES;
        //    cell.textLabel.minimumScaleFactor = 0.45f;
        UIView *aView = [[UIView alloc] initWithFrame:cell.contentView.frame];
        aView.backgroundColor = self.cellTintColor;
        cell.selectedBackgroundView = aView;
    }
    
    NSInteger index = indexPath.row;
    NSString* cellTitle;
    if(index <= [self.titles count]) {
        cellTitle = [self.titles objectAtIndex:index];
    }
    cell.textLabel.text = cellTitle;
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    if (self.indexingBlock) {
        NSInteger index = indexPath.row;
        if(index >= [self.titles count]) {
            self.key = nil;
            return;
        }
        NSString* key = self.titles[index];
        if(!key) {
            self.key = key;
            return;
        }
        if(self.key && [self.key isEqualToString:key]) {
            return;
        }
        self.key = key;
        self.indexingBlock(self, index, self.key);
        
        self.indexingBlock(self,indexPath.row,[self.titles objectAtIndex:indexPath.row]);
    }
}

@end
