//
//  UILabel+WXIntercept.h
//  Eprescription_Patient
//
//  Created by rocky on 16/3/11.
//  Copyright © 2016年 Ewell. All rights reserved.
//

#import <UIKit/UIKit.h>

@interface UILabel (EWECategory)

@property (strong, nonatomic) NSString *textOriginal;

/*!
 *  根据字体大小 label 字符串 计算label的高度（系统字体）
 *
 *  @param label    要计算的label
 *  @param size     label的大小
 *  @param fontSize 字体大小
 *  @return Label高度
 */
+ (CGFloat)labelHightWithLabel:(UILabel *)label textSize:(CGSize)size SystemFontSize:(float)fontSize;
+ (CGFloat)getTextHeightWithText:(NSString*)text font:(UIFont*)font width:(CGFloat)width;

- (CGFloat)labelHeightWithLabelWidth:(CGFloat)width;

@end


/**
 有内边距的UILabel
 */
@interface InsetsLabel : UILabel

@property(nonatomic) UIEdgeInsets insets;

-(id) initWithFrame:(CGRect)frame andInsets: (UIEdgeInsets) insets;
-(id) initWithInsets: (UIEdgeInsets) insets;

@end
