//
//  UILabel+WXIntercept.m
//  Eprescription_Patient
//
//  Created by rocky on 16/3/11.
//  Copyright © 2016年 Ewell. All rights reserved.
//

#import "UILabel+EWECategory.h"
#import <objc/runtime.h>
static void* textOriginalKey = &textOriginalKey;
@implementation UILabel (EWECategory)
@dynamic textOriginal;
+ (void)initialize
{
    // 获取到UILabel中setText对应的method
    Method setText = class_getInstanceMethod([UILabel class], @selector(setText:));
    Method setTextMySelf = class_getInstanceMethod([self class], @selector(setTextHooked:));

    // 将目标函数的原实现绑定到setTextOriginal Implemention方法上
    IMP setTextImp = method_getImplementation(setText);
    class_addMethod([UILabel class], @selector(setTextOriginal:), setTextImp, method_getTypeEncoding(setText));

    // 然后用我们自己的函数的实现，替换目标函数对应的实现
    IMP setTextMySelfImp = method_getImplementation(setTextMySelf);
    class_replaceMethod([UILabel class], @selector(setText:), setTextMySelfImp, method_getTypeEncoding(setText));
}

- (void)setTextHooked:(NSString*)string
{

    //在这里插入过滤算法
    //string = [string stringByReplacingOccurrencesOfString:@" " withString:@"\r\n"];
    if ([string isKindOfClass:[NSNumber class]]) {
        string = [NSString stringWithFormat:@"%@", string];
    }
    else if (!string || [string isKindOfClass:[NSNull class]]) {
        string = @"";
    }
    else if (![string isKindOfClass:[NSString class]]) {
        string = [NSString stringWithFormat:@"%@", string];
    }
    string = [string stringByReplacingOccurrencesOfString:@"(null)" withString:@""];
    if ([self isHtmlStr:string]) {
        //self.attributedText = [self AttributedStringFromHtmlString:string];
        return;
    }
    // do something what ever you want

    // invoke original implemention
    [self performSelector:@selector(setTextOriginal:) withObject:string];
}


- (CGFloat)labelHeightWithLabelWidth:(CGFloat)width{
    CGFloat textHeight;
    CGFloat attTextHeight;
    
    CGSize size = CGSizeMake(width, MAXFLOAT);
    
    NSDictionary* attributes = @{
                                 NSFontAttributeName : self.font,
                                 };
    CGRect expectedLabelRect = [self.text boundingRectWithSize:(CGSize) { width, CGFLOAT_MAX }
                                                        options:NSStringDrawingUsesLineFragmentOrigin
                                                     attributes:attributes
                                                        context:nil];
    textHeight = CGRectGetHeight(expectedLabelRect);
    
    CGRect rect = [self.attributedText boundingRectWithSize:size
                                                     options:NSStringDrawingUsesLineFragmentOrigin
                                                     context:nil];
    attTextHeight = CGRectGetHeight(rect);
    return MAX(textHeight, attTextHeight);
}


- (BOOL)isHtmlStr:(NSString*)str
{

    if ([str rangeOfString:@"<html>"].location != NSNotFound) {
        return YES;
    }
    return NO;
}
- (NSAttributedString*)AttributedStringFromHtmlString:(NSString*)htmlString
{
    return [[NSAttributedString alloc] initWithData:[htmlString dataUsingEncoding:NSUnicodeStringEncoding] options:@{ NSDocumentTypeDocumentAttribute : NSHTMLTextDocumentType } documentAttributes:nil error:nil];
}

+ (CGFloat)labelHightWithLabel:(UILabel*)label textSize:(CGSize)size SystemFontSize:(float)fontSize
{
    CGFloat textHeight;
    CGFloat attTextHeight;
    NSDictionary* attributes = @{
        NSFontAttributeName : label.font,
    };
    CGRect expectedLabelRect = [label.text boundingRectWithSize:(CGSize) { size.width, CGFLOAT_MAX }
                                                        options:NSStringDrawingUsesLineFragmentOrigin
                                                     attributes:attributes
                                                        context:nil];
    textHeight = CGRectGetHeight(expectedLabelRect);

    CGRect rect = [label.attributedText boundingRectWithSize:size
                                                     options:NSStringDrawingUsesLineFragmentOrigin
                                                     context:nil];
    attTextHeight = CGRectGetHeight(rect);
    return MAX(textHeight, attTextHeight);
}

+ (CGFloat)getTextHeightWithText:(NSString*)text font:(UIFont*)font width:(CGFloat)width
{
    if ([self isHtmlStr:text]) {
        CGRect rect = [[self AttributedStringFromHtmlString:text] boundingRectWithSize:CGSizeMake(width, 1000)
                                                                               options:NSStringDrawingUsesLineFragmentOrigin
                                                                               context:nil];
        return CGRectGetHeight(rect);
    }
    else {
        NSDictionary* attributes = @{
            NSFontAttributeName : font,
        };
        CGRect expectedLabelRect = [text boundingRectWithSize:(CGSize) { width, CGFLOAT_MAX }
                                                      options:NSStringDrawingUsesLineFragmentOrigin
                                                   attributes:attributes
                                                      context:nil];
        return CGRectGetHeight(expectedLabelRect);
    }
}
/**
 *  textStr 为 htmlstr
 *
 *  @param str 被检测Str
 *
 *  @return return 检测结果
 */
+ (BOOL)isHtmlStr:(NSString*)str
{

    if ([str rangeOfString:@"<html>"].location != NSNotFound || [str rangeOfString:@"<HTML>"].location != NSNotFound) {
        return YES;
    }
    return NO;
}
+ (NSAttributedString*)AttributedStringFromHtmlString:(NSString*)htmlString
{
    return [[NSAttributedString alloc] initWithData:[htmlString dataUsingEncoding:NSUnicodeStringEncoding] options:@{ NSDocumentTypeDocumentAttribute : NSHTMLTextDocumentType }
                                 documentAttributes:nil
                                              error:nil];
}

@end


@interface InsetsLabel ()

@end

@implementation InsetsLabel

-(id) initWithFrame:(CGRect)frame andInsets:(UIEdgeInsets)insets {
    self = [super initWithFrame:frame];
    if(self){
        self.insets = insets;
    }
    return self;
}

-(id) initWithInsets:(UIEdgeInsets)insets {
    self = [super init];
    if(self){
        self.insets = insets;
    }
    return self;
}

-(void) drawTextInRect:(CGRect)rect {
    return [super drawTextInRect:UIEdgeInsetsInsetRect(rect, self.insets)];
}

@end


