//
//  EWEPopupCell.m
//  EWEllUI_Component
//
//  Created by Niku on 16/11/8.
//  Copyright © 2016年 EWEll. All rights reserved.
//

#import "EWEPopupCell.h"
@interface EWEPopupCell()
@property(nonatomic, strong) UILabel *labContent;
@property(nonatomic, strong) UILabel *labLine;
@end
@implementation EWEPopupCell

- (instancetype) initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
        [self InitializeUI];
    }
    return self;
}

- (void) InitializeUI
{
    self.labContent = [[UILabel alloc] init];
    self.labContent.lineBreakMode = NSLineBreakByWordWrapping;
    self.labContent.numberOfLines = 0;
    self.labContent.adjustsFontSizeToFitWidth = YES;
    
    [self addSubview:self.labContent];
    
    self.labLine = [[UILabel alloc] init];
    self.labLine.backgroundColor = [UIColor colorWithRed:223.0/255.0f green:223.0/255.0f blue:223.0/255.0f alpha:1.0f];
    [self addSubview:self.labLine];
    
}
- (void)layoutSubviews
{
    [super layoutSubviews];
    self.labContent.frame = CGRectMake(0, 0, self.frame.size.width, self.frame.size.height);
    self.labLine.frame = CGRectMake(self.frame.size.width / 4, self.frame.size.height - 1, self.frame.size.width / 2, 1);
}
- (void)setUIconfig{
    self.labContent.textAlignment = self.textAlignment;
    self.labContent.textColor = self.cellTintColor;
    self.labContent.font = self.font;
}
- (void)bindWithString:(NSString *)string{
    self.labContent.text = string;
}

- (void)awakeFromNib {
    [super awakeFromNib];
    
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];
    
}


@end
