//
//  EWEPopupMenu.m
//  EWEllUI_Component
//
//  Created by Niku on 16/11/8.
//  Copyright © 2016年 EWEll. All rights reserved.
//

#import "EWEPopupMenu.h"
#import "EWEPopupCell.h"

@interface EWEPopupMenu()<UITableViewDelegate,UITableViewDataSource>
@property (strong, nonatomic) UITableView* tavList;
@property (strong, nonatomic) UIImageView *imvbg;
@property (strong, nonatomic) NSString* key;
@end
@implementation EWEPopupMenu

- (instancetype)init{
    if (self = [super init]) {
        
        self.imvbg = [[UIImageView alloc] init];
        self.imvbg.frame = CGRectMake(0, 0, 0, 0);
        self.imvbg.image = self.imgbg;
        [self addSubview:self.imvbg];
        
        self.tavList = [[UITableView alloc] init];
        self.tavList.backgroundColor = [UIColor clearColor];
        self.tavList.separatorStyle = UITableViewCellSeparatorStyleNone;
        self.tavList.showsVerticalScrollIndicator = NO;
        self.tavList.delegate = self;
        self.tavList.dataSource = self;
        self.tavList.frame = CGRectMake(0, 0, 0, 0);
        [self addSubview:self.tavList];
        
    }
    return self;
}

- (void)layoutSubviews{
    [super layoutSubviews];
    self.imvbg.frame = CGRectMake(0, 0, self.frame.size.width, self.frame.size.height);
    self.tavList.frame = CGRectMake(0, 0, self.frame.size.width, self.frame.size.height);
}

#pragma mark - tableview delegate

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return self.titles.count;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPat{
    return self.cellHeight;
}

- (UITableViewCell*)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    static NSString* ID = @"Cell";
    EWEPopupCell* cell = [tableView dequeueReusableCellWithIdentifier:ID];
    if (!cell) {
        cell = [[EWEPopupCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:ID];
        cell.backgroundColor = [UIColor clearColor];
        cell.font  = self.font;
        cell.cellTintColor = self.cellTintColor;
        cell.textAlignment = self.textAlignment;
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
    }
    [cell setUIconfig];
    
    NSInteger index = indexPath.row;
    NSString* cellTitle;
    if(index <= [self.titles count]) {
        cellTitle = [self.titles objectAtIndex:index];
        [cell bindWithString:cellTitle];
    }
    return cell;}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    if (self.indexingBlock) {
        NSInteger index = indexPath.row;
        if(index >= [self.titles count]) {
            self.key = nil;
            return;
        }
        NSString* key = self.titles[index];
        if(!key) {
            self.key = key;
            return;
        }
//        if(self.key && [self.key isEqualToString:key]) {
//            return;
//        }
        self.key = key;
//        self.indexingBlock(self, index, self.key);
        
        self.indexingBlock(self,indexPath.row,[self.titles objectAtIndex:indexPath.row]);
    }
}
@end
