//
//  EWESpecialVIew.m
//  EWEllUI_Component
//
//  Created by William on 16/9/30.
//  Copyright © 2016年 EWEll. All rights reserved.
//

#import "EWEXibVIew.h"

#define RandomColor [UIColor colorWithRed:arc4random_uniform(255)/255.0 green:arc4random_uniform(255)/255.0 blue:arc4random_uniform(255)/255.0 alpha:1]
#define RGBColor(r,g,b) [UIColor colorWithRed:(r) green:(g) blue:(b) alpha:1]

@implementation EWECycleView

- (void)layoutSubviews{
    [super layoutSubviews];
    self.layer.cornerRadius = self.bounds.size.height/2;
}

@end

@implementation EWERandomColorView

- (void)layoutSubviews{
    [super layoutSubviews];
    self.backgroundColor = RandomColor;
}

@end

@implementation EWERandomColorCycleView

- (void)layoutSubviews{
    [super layoutSubviews];
    self.backgroundColor = RandomColor;
}
@end

@implementation EWERandomOppositeColorCycleView

- (void)layoutSubviews{
    [super layoutSubviews];
    NSArray* colorValueArray = [self originalColorValue];
    CGFloat originalred = [colorValueArray[0] floatValue];
    CGFloat originalgreen = [colorValueArray[1] floatValue];
    CGFloat originalblue = [colorValueArray[2] floatValue];
    CGFloat red = [self randomOpposite:originalred];
    CGFloat green = [self randomOpposite:originalgreen];
    CGFloat blue = [self randomOpposite:originalblue];
    self.backgroundColor = RGBColor(red,green,blue);
}

- (NSArray*)originalColorValue{
    CGFloat red = 0.0;
    CGFloat green = 0.0;
    CGFloat blue = 0.0;
    CGFloat alpha = 0.0;
    [self.backgroundColor getRed:&red green:&green blue:&blue alpha:&alpha];
    return @[@(red), @(green), @(blue), @(alpha)];
}

- (CGFloat)randomOpposite:(CGFloat)colorValue{
    CGFloat tempF = arc4random_uniform(255)/255.0;
    if (fabs(tempF - colorValue) < 0.1f) {
        tempF += 0.5f;
        tempF = tempF * 255;
        tempF = (int)tempF%255;
        tempF = tempF/255.0;
    }
    return tempF;
}

@end