//
//  UIView+EX.m
//  EWell
//
//  Created by pingguo on 16/1/29.
//  Copyright © 2016年 pingguo. All rights reserved.
//

#import "UIView+EWECategory.h"
#import <objc/runtime.h>

@implementation UIView (EWECategory)

/*!
 *  根据tag给UI控件赋值
 *
 *  @param value button 1.选中 0.未选中 textfield or textview String
 *  @param tag
 */
- (void)setSubViewValue:(NSString*)value forTag:(long)tag
{
    id view = [self viewWithTag:tag];
    if ([view isKindOfClass:[UIButton class]]) {
        UIButton* button = (UIButton*)view;
        if ([value isEqualToString:@"1"]) {
            button.selected = YES;
        }
        else {
            button.selected = NO;
        }
    }
    if ([view isKindOfClass:[UITextField class]]) {
        UITextField* textField = (UITextField*)view;
        textField.text = value;
    }
    if ([view isKindOfClass:[UITextView class]]) {
        UITextView* textView = (UITextView*)view;
        textView.text = value;
    }
}

@end

@implementation UIView (AnimationProperty)

#pragma mark - Scale.

NSString* const _recognizerScale = @"_recognizerScale";

- (void)setScale:(CGFloat)scale
{

    objc_setAssociatedObject(self, (__bridge const void*)(_recognizerScale), @(scale), OBJC_ASSOCIATION_RETAIN_NONATOMIC);
    self.transform = CGAffineTransformMakeScale(scale, scale);
}

- (CGFloat)scale
{

    NSNumber* scaleValue = objc_getAssociatedObject(self, (__bridge const void*)(_recognizerScale));
    return scaleValue.floatValue;
}

#pragma mark - Angle.

NSString* const _recognizerAngle = @"_recognizerAngle";

- (void)setAngle:(CGFloat)angle
{

    objc_setAssociatedObject(self, (__bridge const void*)(_recognizerAngle), @(angle), OBJC_ASSOCIATION_RETAIN_NONATOMIC);
    self.transform = CGAffineTransformMakeRotation(angle);
}

- (CGFloat)angle
{

    NSNumber* angleValue = objc_getAssociatedObject(self, (__bridge const void*)(_recognizerAngle));
    return angleValue.floatValue;
}

@end
