//
//  EWEllToastViewController.swift
//  EWEllUI_Component
//
//  Created by William_Xue on 2017/9/8.
//  Copyright © 2017年 薛少杰. All rights reserved.
//

import UIKit
import EWEllUI_Component

class EWEllToastViewController: UIViewController {

    override func viewDidLoad() {
        super.viewDidLoad()
        self.title = "Toast"
        self.view.backgroundColor = #colorLiteral(red: 1, green: 1, blue: 1, alpha: 1)
        
        let btnSuccess = UIButton.init(frame: CGRect(x: 20, y: 74, width: 200, height: 38))
        btnSuccess.backgroundColor = #colorLiteral(red: 0.2549019754, green: 0.2745098174, blue: 0.3019607961, alpha: 1)
        btnSuccess.setTitle("文字Toast", for: .normal)
        btnSuccess.addTarget(self, action: #selector(showMakeToast), for: .touchUpInside)
        
        let btnError = UIButton.init(frame: CGRect(x: 20, y: 124, width: 200, height: 38))
        btnError.backgroundColor = #colorLiteral(red: 0.2549019754, green: 0.2745098174, blue: 0.3019607961, alpha: 1)
        btnError.setTitle("自定义ViewToast", for: .normal)
        btnError.addTarget(self, action: #selector(showToastView), for: .touchUpInside)
        
        
        let btnProgress = UIButton.init(frame: CGRect(x: 20, y: 174, width: 200, height: 38))
        btnProgress.backgroundColor = #colorLiteral(red: 0.2549019754, green: 0.2745098174, blue: 0.3019607961, alpha: 1)
        btnProgress.setTitle("ToastActivity", for: .normal)
        btnProgress.addTarget(self, action: #selector(showToastActivity), for: .touchUpInside)
        
        
        let btnProgress2 = UIButton.init(frame: CGRect(x: 20, y: 224, width: 200, height: 38))
        btnProgress2.backgroundColor = #colorLiteral(red: 0.2549019754, green: 0.2745098174, blue: 0.3019607961, alpha: 1)
        btnProgress2.setTitle("MYActivity", for: .normal)
        btnProgress2.addTarget(self, action: #selector(showMyActivity), for: .touchUpInside)
        
        self.view.addSubview(btnSuccess)
        self.view.addSubview(btnError)
        self.view.addSubview(btnProgress)
        self.view.addSubview(btnProgress2)
        
        // Do any additional setup after loading the view.
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    
    // MARK: - UIAction
    
    func showMakeToast() {
        let toastStyle = CSToastStyle.init(defaultStyle:())
        toastStyle?.backgroundColor = #colorLiteral(red: 0.6000000238, green: 0.6000000238, blue: 0.6000000238, alpha: 1)
        toastStyle?.titleColor = #colorLiteral(red: 0.7450980544, green: 0.1568627506, blue: 0.07450980693, alpha: 1)
        toastStyle?.messageColor = #colorLiteral(red: 0.8549019694, green: 0.250980407, blue: 0.4784313738, alpha: 1)
        self.view.makeToast("简单的文字Toast", duration: TimeInterval.init(3), position: CSToastPositionBottom, style: toastStyle)
    }
    
    func showToastView() {
        let labToast = UILabel()
        labToast.frame = CGRect(x: 0, y: 0, width: 200, height: 100)
        labToast.backgroundColor = #colorLiteral(red: 0.3098039329, green: 0.01568627544, blue: 0.1294117719, alpha: 1)
        labToast.text = "这是一个简单的LabToast"
        labToast.textColor = #colorLiteral(red: 1, green: 1, blue: 1, alpha: 1)
        self.view.showToast(labToast)
    }
    
    
    func showToastActivity(){
        let toastStyle = CSToastStyle.init(defaultStyle:())
        toastStyle?.backgroundColor = UIColor.clear
        toastStyle?.titleColor = #colorLiteral(red: 0.1019607857, green: 0.2784313858, blue: 0.400000006, alpha: 1)
        toastStyle?.messageColor = #colorLiteral(red: 0.8039215803, green: 0.8039215803, blue: 0.8039215803, alpha: 1)

        CSToastManager.setSharedStyle(toastStyle)
        CSToastManager.setDefaultActivityIndicatorViewStyle(.gray)
        
        self.view.makeToastActivity(self.view.center)
        
        DispatchQueue.main.asyncAfter(deadline: DispatchTime.now() + 3) { 
            self.view.hideToastActivity()
        }
        
    }
    
    func showMyActivity() {
        let iamges = [#imageLiteral(resourceName: "refresh_loading_1"),#imageLiteral(resourceName: "refresh_loading_2"),#imageLiteral(resourceName: "refresh_loading_3"),#imageLiteral(resourceName: "refresh_loading_4"),#imageLiteral(resourceName: "refresh_loading_5"),#imageLiteral(resourceName: "refresh_loading_6"),#imageLiteral(resourceName: "refresh_loading_7"),#imageLiteral(resourceName: "refresh_loading_8"),#imageLiteral(resourceName: "refresh_loading_9"),#imageLiteral(resourceName: "refresh_loading_10"),#imageLiteral(resourceName: "refresh_loading_11")]
        let image = UIImage.animatedImage(with: iamges, duration: 1.0)
        
        self.view.makeToast(nil, duration: 3, position: CSToastPositionBottom, title: nil, image: image, style: CSToastManager.sharedStyle(), completion: nil)
    }
}
