//
//  EWEllViewController.m
//  EWEllUI_Component
//
//  Created by 薛少杰 on 09/06/2017.
//  Copyright (c) 2017 薛少杰. All rights reserved.
//

#import "EWEllViewController.h"
#import "EWEllUI_Component_Example-Swift.h"

#define Screen_W [[UIScreen mainScreen] bounds].size.width
#define Screen_H [[UIScreen mainScreen] bounds].size.height

@interface EWEllViewController ()<UITableViewDelegate,UITableViewDataSource>

@property (strong,nonatomic) UITableView *tavList;

@property (copy,nonatomic) NSArray *vcList;

@end

@implementation EWEllViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    self.automaticallyAdjustsScrollViewInsets = false;
    self.tavList = [[UITableView alloc] initWithFrame:CGRectMake(0, 64, Screen_W, Screen_H - 64) style:UITableViewStyleGrouped];
    self.tavList.contentInset = UIEdgeInsetsMake(10, 0, 10, 0);
    self.tavList.dataSource = self;
    self.tavList.delegate = self;
    [self.view addSubview:self.tavList];
    
    UIBarButtonItem *btnBack = [[UIBarButtonItem alloc] initWithTitle:@"" style:UIBarButtonItemStyleDone target:nil action:nil];
    self.navigationItem.backBarButtonItem = btnBack;
    
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - UITableViewDelegate&&UITableViewDataSource

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return self.vcList.count;
}

- (CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section{
    return 0.01f;
}

-(CGFloat)tableView:(UITableView *)tableView heightForFooterInSection:(NSInteger)section{
    return 0.01f;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    static NSString* CellIdentifier = @"CellIdentifier";
    UITableViewCell* cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (!cell) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier];
    }
    NSDictionary* dict = self.vcList[indexPath.row];
    cell.textLabel.text = dict[@"name"];
    cell.detailTextLabel.text = dict[@"description"];
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    
    NSDictionary* dict = self.vcList[indexPath.row];
    NSString* className = dict[@"className"];
    Class class = NSClassFromString(className);
    id vcID = [[class alloc] init];
    UIViewController* vc = (UIViewController*)vcID;
    [self.navigationController pushViewController:vc animated:YES];
}

#pragma mark - Getting && Setting

- (NSArray *)vcList{
    if (!_vcList) {
        _vcList = @[
                    @{@"name":@"SVProgressHUD",
                      @"description":@"Example for SVProgressHUD",
                      @"className":@"EWEllUI_Component_Example.EWEllProgressHUDViewController"
                    },
                    @{@"name":@"EWEPullDownMenu",
                      @"description":@"Example for EWEPullDownMenu",
                      @"className":@"EWEllUI_Component_Example.EWEllPullDownViewController"
                      },
                    @{@"name":@"Toast",
                      @"description":@"Example for Toast",
                      @"className":@"EWEllUI_Component_Example.EWEllToastViewController"
                      }
                   ].mutableCopy;
    }
    return _vcList;
}



@end
